#!/usr/bin/perl
##############################################################################
#
#  ETS -- Wolfenstein: Enemy Territory Statistics
#  (c) <cade@bis.bg> 2003
#  http://soul.datamax.bg/~cade/away/ets
#
#  Developed for play.evrocom.net server ET community
#  http://play.evrocom.net
#
#  This software is distributed under GPL license, see COPYING for details.
#
#  $Id: ets.pl,v 1.6 2003/07/12 17:36:25 cade Exp $
#
##############################################################################
use strict;

###CONFIG#####################################################################

my $floor = 100;

my $html_header = "<html>
        <title>Wolfenstein: Enemy Territory Statistics</title>
        <style>
        <!--
        BODY  { margin: 0px 0px 0px 0px; color: #fff;
                background-color: #111;
                background-image: url(etback.jpg);
                background-repeat: no-repeat;
                background-position top center;
                background-attachment: fixed; }
        TABLE { font-family: monospace; background-color: #888; }
        TR.hh { border: solid 1px #aaa; background-color: #777; font-weight: bold; }
        TR.r1 { border: solid 1px #aaa; background-color: #444; }
        TR.r2 { border: solid 1px #aaa; background-color: #555; }
        A     { font-family: monospace; color: #0ff; text-decoration: none; }
        -->
        </style>
        <center>
        <p>
        <h1>Wolfenstein: Enemy Territory Statistics</h1>
        <p>
        |
        <a href=players.html>players</a> |
        <a href=clans.html>clans</a> |
        <a href=kdr_p.html>players k/d ratio</a> |
        <a href=kdr_c.html>clans k/d ratio</a> |
        <a href=classide.html>sides/classes</a> |
        <br>
        |
        <a href=wep.html>weapons</a> |
        <a href=uniforms.html>uniforms/disguise</a> |
        <a href=kpm.html>kills per minute</a> |
        <a href=noise_p.html>player noise</a> |
        <a href=noise_c.html>clan noise</a> |
        <br>
        |
        <a href=p_soldier.html>soldier</a> |
        <a href=p_medic.html>medic</a> |
        <a href=p_engineer.html>engineer</a> |
        <a href=p_field_ops.html>field_ops</a> |
        <a href=p_covert_ops.html>covert_ops</a> |
        <br>
        |
        <a href=p_axis.html>axis</a> |
        <a href=p_allies.html>allies</a> |
        <p>
        [TIME]
        <p>
        ";

my $html_footer = "<p>
       Note: Limit is set to first $floor entries (the rest are counted but not shown).<p>
       Thanks to all players at <a href=http://play.evrocom.net>http://play.evrocom.net</a>!<br>
       <b>ETS</b> by (c) <a href=mailto:cade\@bis.bg>&lt;cade\@bis.bg&gt;</a> 2003
       </center>
       </html>";

my $html_motd = "<h2>Welcome to server statistics page for play.evrocom.net!</h2>";

###STATIC#####################################################################

my %CLASS = (
            0 => 'SOLDIER',
            1 => 'MEDIC',
            2 => 'ENGINEER',
            3 => 'FIELD_OPS',
            4 => 'COVERT_OPS',
            );
            
my %SIDE  = (
            0 => 'UNKNOWN',
            1 => 'AXIS',
            2 => 'ALLIES',
            3 => 'SPECTATORS',
            );            

# thanx, furioso :)
my %COLOR = (
            '1' => 'f70400',
            '2' => '02f702',
            '3' => 'fdf900',
            '4' => '0006f8',
            '5' => '00f6f3',
            '6' => 'f407f5',
            '7' => 'f9f9f9',
            '8' => 'ff7b06',
            '9' => '7c7d81',
            '0' => '000100',
            'q' => 'f70303',
            ')' => 'f70303',
            'w' => 'f4f6f1',
            'e' => '8100fd',
            'r' => '00f904',
            't' => '0005f4',
            'y' => '7b7d7a',
            'u' => '00faf6',
            'i' => 'fb0033',
            'o' => 'eff174',
            'p' => '060702',
            'a' => 'fd9534',
            's' => 'fbf904',
            'd' => '007dfe',
            'f' => '3795c8',
            '&' => '3795c8',
            'g' => 'c2fcc9',
            'h' => '066432',
            '(' => '066432',
            'j' => 'ad1c17',
            'k' => '9b3107',
            'l' => 'cf9834',
            ';' => 'c0bfc7',
            'z' => 'bcbdc2',
            'x' => 'f98000',
            'c' => '7b0484',
            'v' => 'f900f9',
            'b' => '037d7e',
            'n' => 'faf9c0',
            'm' => '9b9935',
            ',' => 'cf9a3a',
            '.' => 'f7f8b6',
            '/' => 'fbfc7c',
            '-' => '98972d',
            '=' => '7f7f00',
            '\\' => '007f03',
            '[' => 'bec0bb',
            ']' => '7f7c0b',
            '\'' => 'c5f9c8',
            '*' => 'ae181a',
            );

###MAIN#######################################################################

die "usage: $0 log-file html-output-dir\n" unless @ARGV == 2;

my $log_file = shift;
my $html_dir = shift;

my %gun;

my %kil;
my %ded;
my %kil2;
my %ded2;

my %wep;  # wepon usage by weapon -> count
my %wep2; # weapon usage by players/clans -> weapon
my %wep3; # weapon usage by weapons -> player/clan

my %nam;
my %nam_clr;

my %kdr;  # kill/death ratio

my %unif_taken; # uniforms taken
my %unif_lost; # uniforms lost

my %noise; # noise in words :)

my %class_last; # last classes per player
my %class; # classes per player

my %side_last; # last side per player
my %side; # side per player

my %global_class;
my %global_side;

my %classes;
my %sides;

my %client; # clients info

my $href = 0;
my %href;

my $minute; # used for top kills per minute
my %kpm_temp;
my %kpm;

#-----------------------------------------------------------------------------

print STDERR "processing log file: $log_file\n";

open( my $i, $log_file ) or die "$0: cannot open log file: $log_file\n";
while(<$i>)
  {
  s/<world>/*WORLD*/gi;
  s/^\s*(\d+):(\d+)\s*//; # get time
  my $time = $1 * 60 + $2;
  $minute = $1;
  s/\^.//g; # clear colors etc.
  
  if( /Kill: (\d+) (\d+) (\d+): (.+) killed (.+) by MOD_([A-Z_]+)/i )
    {
    $gun{ $3 } |= $6;
    
    $kpm_temp{ $4 }{ $minute }++;
    $kpm_temp{ get_clan( $4 ) }{ $minute }++;
    
    die "mismatched gun name: $6" if $gun{ $3 } ne $6;
    
    # kills
    $kil{ $4 }++;
    $kil{ get_clan( $4 ) }++;
    $kil2{ $4 }{ $5 }++;
    $kil2{ get_clan( $4 ) }{ get_clan( $5 ) }++;
    
    # deaths
    $ded{ $5 }++;
    $ded{ get_clan( $5 ) }++;
    $ded2{ $5 }{ $4 }++;
    $ded2{ get_clan( $5 ) }{ get_clan( $4 ) }++;
    
    # weapon usage
    $wep{ $6 }++;
    $wep2{ $4 }{ $6 }++;
    $wep2{ get_clan( $4 ) }{ $6 }++;
    $wep3{ $6 }{ $4 }++;
    $wep3{ $6 }{ get_clan( $4 ) }++;
    
    # get names...
    $nam{ $4 }++;
    $nam{ $5 }++;
    $nam{ get_clan( $4 ) }++;
    $nam{ get_clan( $5 ) }++;

    print STDERR "unknown: $_\n" if $6 eq '';
    next;
    }
  if( /^say(team)?: ([^:]+): (.+)/i )
    {
    my $p = $2;
    my $cnt = $3 =~ /\S+/g;
    $noise{ $p } += $cnt;
    $noise{ get_clan( $p ) } += $cnt;
    }
  if( /^ClientUserinfoChanged: (\d+) (.+)/i )
    {
    # n\xwayBG\t\2\c\4\r\0\m\0000000\s\0000000\dn\chromosome\dr\0\w\10\lw\10\sw\41\mu\0\ref\0
    my $id = $1;
    my $data = $2;
    $client{ $id } = { split /\\/, $data };
    
    my $name = $client{ $id }{ 'n' };
    my $dn = $client{ $id }{ 'dn' };
    my $class = $CLASS{ $client{ $id }{ 'c' } };
    my $side = $SIDE{ $client{ $id }{ 't' } };
    if( $dn )
      {
      $unif_taken{ $name }++;
      $unif_lost{ $dn }++;
      };
    if( $class_last{ $name } ne $class )
      {
      $class{ $name }{ $class }++;
      $class{ get_clan( $name ) }{ $class }++;
      $class_last{ $name } = $class;
      $global_class{ $class }++;
      $classes{ $class }{ $name }++;
      $classes{ $class }{ get_clan( $name ) }++;
      }
    if( $side_last{ $name } ne $side )
      {
      $side{ $name }{ $side }++;
      $side{ get_clan( $name ) }{ $side }++;
      $side_last{ $name } = $side;
      $global_side{ $side }++;
      $sides{ $side }{ $name }++;
      $sides{ $side }{ get_clan( $name ) }++;
      }
    }
  }
close($i);

print STDERR "done\n";

#-----------------------------------------------------------------------------

print STDERR "processing data...\n";

# fix names links
for my $k ( keys %nam )
  {
  my $k2 = $k;
  $k2 =~ s/[^!a-z0-9\-\_]/_/gi;
  $href{ $k } = lc $k2;
  }

# calc things  
for my $p ( keys %nam )
  {
  my $k = $kil{ $p } || 0;
  my $d = $ded{ $p } || 0;
  my $r = $d > 0 ? sprintf "%.2f", $k / $d : 'n/a';

  $kdr{ $p } = $r;
  }

while( my ( $k, $v ) = each %kpm_temp )
  {
  my ( $max_k, $max_v ) = hash_max( $v );
  # $k = sprintf "minute %08d  %s", $max_k, $k;
  $kpm{ $k } = $max_v;
  }

print STDERR "done\n";

#-----------------------------------------------------------------------------

html_save( 'index', $html_motd );

html_save( 'players', mod_player_stats() );
html_save( 'clans', mod_clan_stats() );

for my $k ( keys %classes )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_generic_stats( "$k (totals per clan)", $classes{ $k }, CLAN => 1 ),
                               mod_generic_stats( "$k", $classes{ $k } ) );
  }
for my $k ( keys %sides )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_generic_stats( "$k (totals per clan)", $sides{ $k }, CLAN => 1 ),
                               mod_generic_stats( "$k", $sides{ $k } ) );
  }
for my $k ( keys %wep3 )
  {
  $href{ $k } = lc $k;
  html_save( 'p_' . $href{$k}, mod_generic_stats( "weapon $k used by clan:", $wep3{ $k }, CLAN => 1 ),
                               mod_generic_stats( "weapon $k used by player:", $wep3{ $k } ) );
  }
for my $k ( sort { $kil{ $b } <=> $kil{ $a } } keys %nam )
  {
  html_save( 'p_' . $href{$k}, mod_generic_stats( "sides played by " . color_name( $k ), $side{ $k } ),
                               mod_generic_stats( "classes played by " . color_name( $k ), $class{ $k } ),
                               mod_generic_stats( "preferred weapons by " . color_name( $k ), $wep2{ $k } ),
                               mod_generic_stats( color_name( $k ) . " killed: ", $kil2{ $k }, CLAN => $k =~ /^!/ ),
                               mod_generic_stats( color_name( $k ) . " was killed by: ", $ded2{ $k }, CLAN => $k =~ /^!/ ) );
  }

html_save( 'kdr_p',    mod_generic_stats( "kill/death ratio by players", \%kdr, NOP => 1 ) );
html_save( 'kdr_c',    mod_generic_stats( "kill/death ratio by clans", \%kdr, NOP => 1, CLAN => 1 ) );

html_save( 'noise_p',  mod_generic_stats( "noise in words by player", \%noise ) );
html_save( 'noise_c',  mod_generic_stats( "noise in words by clan", \%noise, CLAN => 1 ) );

html_save( 'uniforms', mod_generic_stats( "uniforms taken", \%unif_taken ),
                       mod_generic_stats( "uniforms lost", \%unif_lost ) );

html_save( 'kpm',      mod_generic_stats( "kills per minute by clan",   \%kpm, NOP => 1, CLAN => 1 ),
                       mod_generic_stats( "kills per minute by player", \%kpm, NOP => 1 ) );

html_save( 'classide', mod_generic_stats( "sides played", \%global_side ),
                       mod_generic_stats( "classes played", \%global_class ) );

html_save( 'wep', mod_generic_stats( "preferred weapons", \%wep ) );


##############################################################################

sub mod_player_stats
{
  return mod_player_clan_stats( CLAN => 0 );
}

sub mod_clan_stats
{
  return mod_player_clan_stats( CLAN => 1 );
}

sub mod_player_clan_stats
{
  my %opt = @_;
  my $clan = $opt{ 'CLAN' };

  my $text;
  
  $text .= "<p>";
  $text .= $clan ? "<h2>Clans</h2>" : "<h2>Players</h2>";
  $text .= "<table width=80% cellspacing=1 cellpadding=5>\n";
  $text .= "<tr class=hh>
               <td width=05% align=right>#</td>
               <td width=15%>Clan</td>
               <td width=30%>Player/Clan</td>
               <td width=10% align=right>Kills</td>
               <td width=10% align=right>Deaths</td>
               <td width=10% align=right>K/D</td>
               <td width=20%>Prefered Weapon</td>
            </tr>";
  my $row = 0;
  my $sum_k = 0;
  my $sum_d = 0;
  for my $p ( sort { $kil{ $b } <=> $kil{ $a } } keys %nam )
    {
    next if $clan and $p !~ /^!/;
    next if !$clan and $p =~ /^!/;

    my $k = $kil{ $p } || 0;
    my $d = $ded{ $p } || 0;
    my $r = $kdr{ $p };
    my $w;
    
    ( $w, undef ) = hash_max( $wep2{ $p } );
    
    $w ||= 'n/a';
    
    my $c = get_clan( $p );
    
    my $target1 = $href{ $c };
    my $target2 = $href{ $p };
    
    $p =~ s/>/&gt;/g;
    $p =~ s/</&lt;/g;
    
    $sum_k += $k;          
    $sum_d += $d;          
    
    if ( $row <= $floor )
      {
      $row++;
      my $class = tr_class();
      $p = color_name( $p );
      $c = color_name( $c );
      $text .= "<tr class=$class>
                   <td align=right>$row</td>
                   <td><a href=p_$target1.html>$c</a></td>
                   <td><a href=p_$target2.html>$p</a></td>
                   <td align=right>$k</td>
                   <td align=right>$d</td>
                   <td align=right>$r</td>
                   <td><a href=wep.html>$w</a></td>
                </tr>";
      }
    }
  $text .= "<tr class=hh>
               <td width=05% align=right></td>
               <td width=15%></td>
               <td width=30%></td>
               <td width=10% align=right>$sum_k</td>
               <td width=10% align=right>$sum_d</td>
               <td width=10% align=right></td>
               <td width=20%></td>
            </tr>";
  $text .= "</table>\n";
  $text .= "\n\n\n\n";
  return $text;
}

sub mod_generic_stats
{
  my $title = shift;
  my $hr    = shift;
  my %opt   = @_;
  my $text;

  my $clan = $opt{ 'CLAN' };
  
  my $sum = hash_sum( $hr );
  
  $text .= "<p>";
  $text .= "<h2>$title</h2>";
  $text .= "<table width=80% cellspacing=1 cellpadding=5>\n";
  $text .= "<tr class=hh>
               <td width=05% align=right>#</td>
               <td width=40%>Name</td>
               <td width=30% align=right>Value</td>
               <td width=25% align=right>Percentage</td>
            </tr>";
  my $row = 0;
  for my $k ( sort { $hr->{ $b } <=> $hr->{ $a } } keys %$hr )
    {
    next if $clan and $k !~ /^!/;
    next if !$clan and $k =~ /^!/;
    
    my $v = $hr->{ $k };
    my $p = $sum > 0 ? sprintf "%.2f%%", 100 * $v / $sum : 'n/a';
    
    if( $href{ $k } )
      {
      $k = "<a href=p_$href{$k}.html>".color_name( $k )."</a>";
      }
    else
      {
      $k = color_name( $k );
      }  
    
    $p = 'n/a' if $opt{ 'NOP' };
    
    $row++;
    my $class = tr_class();
    $text .= "<tr class=$class>
                 <td align=right>$row</td>
                 <td>$k</td>
                 <td align=right>$v</td>
                 <td align=right>$p</td>
              </tr>" if $floor >= $row;
    }
  $text .= "<tr class=hh>
               <td align=right></td>
               <td>Total:</td>
               <td align=right>$sum</td>
               <td align=right></td>
            </tr>" unless $opt{ 'NOP' };
  $text .= "</table>\n";
  $text .= "\n\n\n\n";
  return $text;
}

##############################################################################

sub html_save
{
  my $file = shift;
  $file = "$html_dir/$file.html";
  open(my $o, '>' . $file) or die "$0: cannot save html file: $file\n";
  my $text = join '', $html_header, @_, $html_footer;
  my $time = scalar localtime();
  $text =~ s/\[TIME\]/$time/g;
  print $o $text;
  close($o);
  print STDERR "file $file written ok\n";
}

sub color_name
{
  my $s = shift;
  my $c = $s =~ s/\^(.)/"<font color=#$COLOR{$1}>"/gie;
  $s .= "</font>" x $c;
  return $s;
}

my $static_tr;

sub tr_class
{
  $static_tr = !$static_tr;
  $static_tr ? 'r1' : 'r2';
}

sub hash_max
{
  my $hr = shift;
  my $max_k = undef;
  my $max_v = undef;
  while( my ( $k, $v ) = each %$hr )
    {
    if( $max_v eq '' or $v > $max_v )
      {
      $max_k = $k;
      $max_v = $v;
      next;
      }
    }
  #print STDERR "$max_k, $max_v\n";
  return ( $max_k, $max_v );
}

sub hash_sum
{
  my $hr = shift;
  my $sum = 0;
  while( my ( $k, $v ) = each %$hr )
    {
    next if $k =~ /^!/;
    $sum += $v;
    }
  return $sum;
}

sub get_clan
{
  my $s = shift;
  my $c = '';
  $c = $1 if $s =~ /^\[([^\]]+)\]/;
  $c = $1 if $s =~ /^([A-Z]{2,5})-/i;
  return uc "!$c";
}

###EOF########################################################################

